/*****************************************************************
*
* PROJECT:        Swiss Perfect 3
*
*                 Copyright (C) 1996 Robert Rozycki
*                 SwissPerfect/SPAR General Public Licence
*
* FILE:           l_msg.h
*
* DESCRIPTION:    This is an abstract Message Manager class from
*                 which Swiss Perfect and OS specific classes
*                 can be derived.
*                 This class contains in-line functions only so no
*                 corresponding *.cpp file can be found.
*
* AUTHOR:         Robert Rozycki     rozycki@perth.dialix.oz.au
*
* PORTABILITY:    ANSI C++
*
* $Revision: 1.1 $
*
* $Date: 1996/02/04 09:55:20 $
*
* $Log: l_msg.h $
 * Revision 1.1  1996/02/04  09:55:20  robert
 * Initial revision
 *
*
*******************************************************************/
#ifndef _L_MSG_H
#define _L_MSG_H

#include "l_types.h"

// debug log levels
enum { LOG_FLOW = 1, LOG_ERROR, LOG_HIGH, LOG_MED, LOG_LOW };

class MsgMngr_c {
public:
   MsgMngr_c() { DebugOn = FALSE; };
   void SetDebug( int state ) { DebugOn = state; };

// In the following functions first parameter is message text
// and the second dialog box title
   virtual void ShowInfo   ( char *, char * ) {};
   virtual void ShowWarning( char *, char * ) {};
   virtual void ShowError  ( char *, char * ) {};
   virtual int  ShowYesNo  ( char *, char * ) { return 0; };

   virtual void InputDialog( char *,   // title 
                             char *,   // prompt 
                             char *,   // buf
                             int )     // count
      {};

   virtual int  WriteToLog ( int,      // debug_level 
                             char *,   // msg 
                             ... )     // argument list
      { return 0; };

protected:
   int DebugOn;
};

#endif _L_MSG_H

