/*****************************************************************
*
* PROJECT:        Swiss Perfect 3
*
*                 Copyright (C) 1996 Robert Rozycki
*                 SwissPerfect/SPAR General Public Licence
*
* FILE:           sws_base.h
*
* DESCRIPTION:
*
* $Author: robert $
*
* PORTABILITY:    ANSI C++
*
* $Revision: 1.1 $
*
* $Date: 1996/02/04 09:54:13 $
*
* $Log: sws_base.h $
 * Revision 1.1  1996/02/04  09:54:13  robert
 * Initial revision
 *
*
*******************************************************************/
#ifndef _SWS_BASE_H
#define _SWS_BASE_H

typedef struct {
  int left;
  int right;
} PAIR;

typedef struct {
  int  *group;
  int   count;
  char *brackets;
  int   rx_floats;
} PAIRED_VEC;

class SwissBase_c {
public:
   SwissBase_c() {};
   virtual ~SwissBase_c() {};

   virtual int MakePairing( PAIR *, int players_count, int round,
                            int = FALSE )
   {
      PlayersToBePaired = players_count;
      PairTablesToBeMade = (players_count >> 1) + (players_count & 0x01);
      RoundNoToPair = round;
      return 0;
   };

protected:
   PAIR *FinalPairing;
   void SaveFinalPairing( PAIR *pairing );

   virtual int  CanPlay        ( int, int )         { return TRUE; };
   virtual int  GetColPref     ( int )              { return 0; };
   virtual char GetUpfStatus   ( int )              { return 0; };
   virtual char GetDnfStatus   ( int )              { return 0; };
   virtual char GetByeStatus   ( int )              { return 0; };
   virtual int  GetGroup       ( int, int&, int& ) { return 0; };

   virtual int  GetPlayerScore ( int )              { return 0; };
   virtual void MapRoundTab   ( PAIR * )            { return; };

   virtual void SortRoundTab  ( PAIR *rtab );
   virtual void FirstRoundCols( PAIR *rtab );
   virtual int  AssignColours ( PAIR *pairing );

   virtual int  ColourHistory( int, int, int ) { return 0; };

   void SwapPair( PAIR *rtab, int pair_no );

   int PlayersToBePaired;
   int PairTablesToBeMade;
   int RoundNoToPair;
};

#endif
