/*****************************************************************
*
* PROJECT:        Swiss Pairing Test Program
*
*                 Copyright (C) 1996 Robert Rozycki
*                 SwissPerfect/SPAR General Public Licence
*
* FILE:           sws_read.h
*
* DESCRIPTION:    Header file for sws_read.cpp
*
* AUTHOR:         Robert Rozycki
*
* PORTABILITY:    ANSI C++
*
* $Revision: 1.2 $
*
* $Date: 1996/02/04 09:47:20 $
*
* $Log: sws_read.h $
 * Revision 1.2  1996/02/04  09:47:20  robert
 * Internet release Feb 1996
 *
*
*******************************************************************/
#ifndef _SWS_READ_H
#define _SWS_READ_H

#include "log.h"
#include "sws_data.h"

class SwissRead_c : public SwissData_c
{
public:
   SwissRead_c( MsgMngr_c *msg_mngr );
   int ReadData( FILE *fdata );

protected:
   int  FirstPass( FILE *fdata );
   int  SecondPass( FILE *fdata );
   int  GetLineType( char *p );
   int  ExamineLine( int line_no, char *p );
   int  GetPlayer( char *p );
   int  StoreOppons( int player, int oppon_count, int forbidden );
   int  NewOppon( int oppon, int opp_idx );
   char *GetOpponents( char *p, int player );
   char *GetColpref( int player, char *p, int line_no );
   char *GetFloats( int player, char *p );

   char LineBuf[ MAX_SWSLINE + 1 ];
   int  MapOption;
   int *PlayerOppons;
};

#endif
