/*****************************************************************
*
* PROJECT:        Swiss Pairing Test Program GNU GPL
*
* FILE:           utils.cpp
*
* DESCRIPTION:
*
* $Author: robert $      Robert Rozycki   rozycki@perth.dialix.oz.au
*
* PORTABILITY:
*
* $Revision: 1.2 $
*
* $Date: 1996/02/04 09:45:48 $
*
* $Log: utils.cpp $
// Revision 1.2  1996/02/04  09:45:48  robert
// Internet release Feb 1996
//
// Revision 1.1  1996/01/01  14:04:01  robert
// Initial revision
//
*
*******************************************************************/

#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include "utils.h"


//////////////////////////////////////////////////////////////////////
//
//  prints out "Out of memory" message
//
int nomem_msg( void )
{
   printf( "alloc_tables(): Out of memory\n" );
   return( -1 );
}

//////////////////////////////////////////////////////////////////////
//
//  prints out a syntax error encountered in the data file
//
void print_error( char *err_text, int line_no )
{
   printf( "Syntax error: %s, in line %d\n", err_text, line_no );
}

//////////////////////////////////////////////////////////////////////
//
//  skips white characters and commas in string "str"
//
char *skip_blanks( char *str )
{
   while( isspace( *str ) || *str == ',' )
      str++;
   return( str );
}

//////////////////////////////////////////////////////////////////////
//
//  skips digits in string "str"
//
char *skip_digits( char *p )
{
   while( isdigit( *p ) )
      p++;
   return( p );
}

//////////////////////////////////////////////////////////////////////
//
//  skips all characters until "separ" or 0 is encountered
//  in string "str"
//
char *goto_separ( char *str, char separ )
{
   while( *str != separ && *str != '\0' )
      str++;
   return( str );
}

//////////////////////////////////////////////////////////////////////
//
//  converts all string characters to upper case
//
char *upper_str( char *str )
{
   char *p;

   p = str;
   while( isalpha( *p ) )
   {
      *p = toupper( *p );
      p++;
   }
   return( str );
}
